# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# This is the Control.py file of FeynMaster
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

#:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: Initial section :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: 
# - - - - - - Choose the operative system ('Windows', 'Linux' or 'Mac')
osswitch = 'Linux'
# - - - - - - Choose the model (example: 'QED')
model = 'QED'
# - - - - - - If the model is not in the directory of Control.py but in a sub-directory inside it, write the name of that sub-directory; else, leave it ''
folder = 'FeynMasterModels'
# - - - - - - (do not edit):
endstr=model if folder == '' else folder+'.'+model; content = getattr(__import__(endstr, fromlist=['content']), 'content')
(intname,extname,nscl,cscl,ancscl,fel,anfel,ngal,cgal,ancgal,ngol,cgol,ancgol,ghl,anghl,glul,LAnscl,LAcscl,LAancscl,LAfel,LAanfel,LAngal,LAcgal,LAancgal,LAngol,LAcgol,LAancgol,LAghl,LAanghl,LAglul,FRtoQ,FRrestr,FCsimp,FCeqs,PrMassFL,rensimp,renconsnum,LArenconsnum,renconsmat,LArenconsmat,renconsmatdim,GFreno,renorrules) = content.values()

def processes(): #:::::::::::::::::::::::::::::::::::::::::::::::::: Processes section :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: 
# - - - - - - (do not edit):
	Seq=[]; Loo=[]; LooTec=[]; Fac=[]; Opt=[]; ParS=[]
# - - - - - - Write the sequence of 1-loop processes you want to study:
	# - - - - - - process 1:
	# - - - - - - - - - - incoming particles, in QGRAF style, separated by commas (example: ['e1', 'WM']), with antiparticles after particles
	InParticles = ['A']
	# - - - - - - - - - - outgoing particles, in QGRAF style, separated by commas (example: ['e1', 'WM']), with antiparticles after particles
	OutParticles = ['f','F']
	# - - - - - - - - - - number of loops, without prime symbols (example: 1):
	loops = 1
	# - - - - - - - - - - selection of particles in the loop: keep or avoid an interval of number of propagators of a certain particle.
	# - - - - - - - - - - example: Parsel = [['avoid','H','1','3'],['keep','WP','1','1']]. If you don't want this option, leave Parsel=[]
	Parsel = []
	# - - - - - - - - - - loop technique in FeynCalc (1 for OneLoop, 2 for MyOneLoop, 3 for MyOneLoopMod, 4 for OneLoopTID):
	LoopTec = 3
	# - - - - - - - - - - quantity to factor out in the end of the computation, in Mathematica style (example: '1' or '4*Pi'):
	factor = '1'
	# - - - - - - - - - - QGRAF options (example: 'onepi'); else, leave it '':
	options = 'onepi'
	# - - - - - - (do not edit):
	Sum = [InParticles,OutParticles]; Seq.append(Sum); 	Loo.append(str(loops)); ParS.append(Parsel)	; LooTec.append(str(LoopTec)); Fac.append(factor); Opt.append(options)
	# - - - - - - end of process 1
	# - - - - - - process 2:
	# - - - - - - - - - - incoming particles, in QGRAF style, separated by commas (example: ['e1', 'WM']), with antiparticles after particles
	InParticles = ['f']
	# - - - - - - - - - - outgoing particles, in QGRAF style, separated by commas (example: ['e1', 'WM']), with antiparticles after particles
	OutParticles = ['f']
	# - - - - - - - - - - number of loops, without prime symbols (example: 1):
	loops = 1
	# - - - - - - - - - - selection of particles in the loop: keep or avoid an interval of number of propagators of a certain particle.
	# - - - - - - - - - - example: Parsel = [['avoid','H','1','3'],['keep','WP','1','1']]. If you don't want this option, leave Parsel=[]
	Parsel = []
	# - - - - - - - - - - loop technique in FeynCalc (1 for OneLoop, 2 for MyOneLoop, 3 for MyOneLoopMod, 4 for OneLoopTID):
	LoopTec = 3
	# - - - - - - - - - - quantity to factor out in the end of the computation, in Mathematica style (example: '1' or '4*Pi'):
	factor = '1'
	# - - - - - - - - - - QGRAF options (example: 'onepi'); else, leave it '':
	options = 'onepi'
	# - - - - - - (do not edit):
	Sum = [InParticles,OutParticles]; Seq.append(Sum); 	Loo.append(str(loops)); ParS.append(Parsel)	; LooTec.append(str(LoopTec)); Fac.append(factor); Opt.append(options)
	# - - - - - - end of process 2
# - - - - - - for more processes, just replicate the above process
	return (Seq,Loo,ParS,LooTec,Fac,Opt)

def selection(): #:::::::::::::::::::::::::::::::::::::::::::::::::: Selection section :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: 
# - - - - - - If you want to establish an interface with FeynRules, choose FRinterLogic as True
	FRinterLogic = True
# - - - - - - If you want to do renormalization, choose RenoLogic as True
	RenoLogic = False
# - - - - - - If you want to draw the Feynman diagrams, choose Draw as True:
	Draw = False
# - - - - - - If you want to compute the final expressions, choose Comp as True:
	Comp = False
	# - - - - - - - - - -  If Comp = True and you want to compute the final result of each diagram, choose FinLogic as True:
	FinLogic = False
	# - - - - - - - - - -  If Comp = True and you want to compute the divergent part of each diagram, choose DivLogic as True:
	DivLogic = False
	# - - - - - - - - - -  If Comp = True and you want to compute the sum of the expressions, choose SumLogic as True:
	SumLogic = False
	# - - - - - - - - - -  If Comp = True and if you want to apply momentum conservation, choose MCLogic as True:
	MoCoLogic = False
	# - - - - - - - - - -  If Comp = True and if you want to include Spinors, choose LoSpinors as True:
	LoSpinors = False
# - - - - - - (do not edit):
	return (FRinterLogic,Draw,Comp,FinLogic,DivLogic,RenoLogic,SumLogic,MoCoLogic,LoSpinors)

def directories(): #:::::::::::::::::::::::::::::::::::::::::::::::::: Directories section :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: 
# - - - - - - the directory corresponding to FeynMaster:
	dirFM = '/(...)/FeynMaster/'
# - - - - - - the directory corresponding to FeynRules:
	dirFR = '/(...)/FeynRules/'
# - - - - - - the directory where the FeynRules model is:
	dirFRmod = '/(...)/FeynRulesModels/' + intname + '/'
# - - - - - - the directory corresponding to QGRAF:
	dirQ = '/(...)/QGRAF/'
# - - - - - - the directory where the QGRAF model is to be found (must be inside dirQ; write only the path inside dirQ):
	dirQmod = 'ModelsFeynMaster/'	
# - - - - - - the directory corresponding to FeynMaster output:
	dirMain = '/(...)/FeynMaster-Output/' + intname + '/'
# - - - - - - Specific directory for the processes:
	dirPro = dirMain + 'Processes/'  	
# - - - - - - The Feynman Rules:
	dirFey = dirMain + 'FeynmanRules/'
# - - - - - - The counterterms:
	dirCT = dirMain + 'Counterterms/'
# - - - - - - (do not edit):	
	return (dirFM,dirFR,dirFRmod,dirMain,dirQ,dirQmod,dirPro,dirFey,dirCT)