(********** This is the FeynRules model file for Scalar QED **********)

(***** Initial information *****)
M$ModelName = "ScalarQED";
M$Information = {Authors -> "Duarte Fontes",
                 Institutions -> "Técnico Lisboa",
                 Emails -> "duartefontes@tecnico.ulisboa.pt",
                 Date -> "16.07.2019"};

(***** Parameter list *****)
M$Parameters = {
  ee == {TeX -> e},
  lbd == {TeX -> \[Lambda]},
  mPhi == {TeX -> Subscript[m, Superscript[H, "-"]]},
  xiA == {TeX -> Subscript[\[Xi],A]}}

(***** Gauge group list *****)
M$GaugeGroups = {
  U1EM == {
		Abelian -> True,
		GaugeBoson -> A,
		Charge -> Q,
		CouplingConstant -> ee}}

(***** Particle classes list *****)
M$ClassesDescription = {
  S[1] == {
		ClassName -> Phi,
		SelfConjugate -> False,
		QuantumNumbers -> {Q-> Q},
		Mass -> mPhi},
  V[1] == {
		ClassName -> A,
		SelfConjugate -> True,
		Mass -> 0}}

(***** Lagrangean parts *****)
LGauge := -1/4 FS[A, \[Mu], \[Nu]] FS[A, \[Mu], \[Nu]]
LHiggs := HC[DC[Phi, \[Mu]]] DC[Phi, \[Mu]] - mPhi^2 HC[Phi] Phi -1/4 lbd (HC[Phi] Phi) (HC[Phi] Phi)
LGF := -1/2/xiA del[A[mu], mu] del[A[nu], nu]