(******************* Parameters *******************)

M$Parameters = {
(********* Gauge parameters *********)
  xiG == {TeX -> Subscript[\[Xi],G]},
  xiA == {TeX -> Subscript[\[Xi],A]},
  xiW == {TeX -> Subscript[\[Xi],W]},
  xiZ == {TeX -> Subscript[\[Xi],Z]},

(********* Romao & Silva eta's (cf. 1209.6213) *********)
  etae == {TeX -> Subscript[\[Eta],e]},
  eta1 == {TeX -> \[Eta]'},
  eta2 == {TeX -> \[Eta]},
  eta3 == {TeX -> Subscript[\[Eta],s]},
  etat == {TeX -> Subscript[\[Eta],\[Theta]]},
  etaZ == {TeX -> Subscript[\[Eta],Z]},

(********* Gauge groups constants *********)
  gw == {TeX -> Subscript[g, w]},
  g1 == {TeX -> Subscript[g, 1]},
  gs == {TeX -> Subscript[g, s]},

(********* Masses *********)
  me == {TeX -> Subscript[m,e], Value -> 0.0005109989461},
  mm == {TeX -> Subscript[m,\[Mu]], Value -> 0.1056583745},
  mtt == {TeX -> Subscript[m,\[Tau]], Value -> 1.77686},
  mu == {TeX -> Subscript[m,u], Value -> 0.0022},
  mc == {TeX -> Subscript[m,c], Value -> 1.275},
  mt == {TeX -> Subscript[m,t], Value -> 173.1},
  md == {TeX -> Subscript[m,d], Value -> 0.0047},
  ms == {TeX -> Subscript[m,s], Value -> 0.095},
  mb == {TeX -> Subscript[m,b], Value -> 4.18},
  MW == {TeX  -> Subscript[m, W], Value -> 80.379},
  MZ == {TeX  -> Subscript[m, Z], Value -> 91.1876},
  MH == {TeX  -> Subscript[m, h], Value -> 125.18},

(********* Remaining parameters *********)
  vv == {TeX -> v},
  ee == {TeX -> e, Value -> 0.302822},
  sw == {TeX -> Subscript[s, w], Value -> 0.4808580293600181},
  cw == {TeX -> Subscript[c, w], Value -> 0.876798469204868}, 
  muH == {TeX -> \[Mu]},
  lbd == {TeX -> \[Lambda]},
  yl == {
		Indices -> {Index[Generation], Index[Generation]},
		TeX -> Y^l,
		Unitary -> True,
		ComplexParameter -> False},
  yu == {
		Indices -> {Index[Generation], Index[Generation]},
		TeX -> Y^u,
		Unitary -> True,
		ComplexParameter -> False},
  yd == {
        Indices -> {Index[Generation], Index[Generation]},
        TeX -> Y^d,
        Unitary -> True,
        ComplexParameter -> False},
  CKM == { 
		Indices -> {Index[Generation], Index[Generation]},
		TeX -> V,
		Values -> {0.97420,0.2243,0.00394,0.218,0.997,0.0422,0.0081,0.0394,1.019},
		Unitary -> True,
		ComplexParameter -> True},

(********* Counterterms *********)
  \[Delta]mu == {
        Indices -> {Index[Generation]},
        AllowSummation -> True},
  \[Delta]md == {
        Indices -> {Index[Generation]},
        AllowSummation -> True},
  \[Delta]ml == {
        Indices -> {Index[Generation]},
        AllowSummation -> True},
  \[Delta]ZdqL == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> True},
  \[Delta]ZdqR == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> True},
  \[Delta]ZuqL == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> True},
  \[Delta]ZuqR == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> True},
  \[Delta]ZlL == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> True},
  \[Delta]ZlR == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> True},
  \[Delta]ZvlL == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> True},
  \[Delta]ZvlR == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> True},                                                
  \[Delta]yl == {
        Indices -> {Index[Generation], Index[Generation]},
        Unitary -> True,
        ComplexParameter -> True},
  \[Delta]yd == {
        Indices -> {Index[Generation], Index[Generation]},
        Unitary -> True,
        ComplexParameter -> True},
  \[Delta]yu == {
        Indices -> {Index[Generation], Index[Generation]},
        Unitary -> True,
        ComplexParameter -> True},   
  \[Eta]dq == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> False},      
  \[Eta]uq == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> False},   
  \[Eta]l == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> False},   
  \[Eta]vl == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> False},                   
  \[Delta]CKM == {
        Indices -> {Index[Generation], Index[Generation]},
        ComplexParameter -> True}
}