(* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
This is Finals.m, to be used in the FeynCalc environment.

Here we take care of the final expressions.

Created by: Duarte Fontes
Email: duartefontes@tecnico.ulisboa.pt
Last update: 04.07.2019
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *)

(* --- The total number of amplitudes  --- *)
imax=1+(StringCases[ReadString["Amplitudes.m"], Longest[{"\n" | "\r"} ..]] // Length);

(* --- Compute the final expressions  --- *)
anc1 = {}; anc2 = {}; anc3 = {}; anc4 = {};
amp = {}; ans = {}; res = {}; resD = {};
For[i = 1, i < imax, i++, anc1 = Append[anc1, {ToString[StringForm["amp``", i]]}]];
Do[ amp = Append[amp,ToExpression[anc1[[j, 1]]]];
  		anc2 = Append[anc2, ToString[StringForm["ans``=GetAns[amp``,k1]", j, j]]];
  		anc3 = Append[anc3, ToString[StringForm["res``=GetRes[ans``] /. FCsimp /. ApplyMomCons", j, j]]];
  		anc4 = Append[anc4, ToString[StringForm["resD``=Simplify[GetDiv[res``] /. FCsimp /. ApplyMomCons]", j, j]]], {j, 1, Length[anc1]}];

Do[ToExpression[anc2[[j]]];
		ans= Append[ans,ToExpression[anc2[[j]]]];  res= Append[res,ToExpression[anc3[[j]]]]; resD= Append[resD,ToExpression[anc4[[j]]]],
						{j, 1,Length[anc2]}];

If[SumLogic, restot = Simplify[Total[res] /. FCsimp /. ApplyMomCons]];
If[SumLogic || RenoLogic, resDtot = Simplify[Total[resD] /. FCsimp /. ApplyMomCons]];