# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - QED - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
content = {
	# - - - - - - Start by writing the 'internal' name of the model, to be used both in the QGRAF model and the Feynrules and FeynMaster-output folders
	'intname' : 'QED',
	# - - - - - - Write the 'external' name of the model, to be printed in the FeynMaster outputs
	'extname' : 'QED',
	# - - - - - - Write the particles of your model in QGRAF style (the antiparticles should be in the respective order)
	'nscl' : [''],    # - - - neutralscalars
	'cscl' : [''],    # - - - chargedscalars
	'ancscl' : [''],    # - - - antichargedscalars
	'fel' : ['f'],    # - - - fermions
	'anfel'  : ['F'],    # - - - antifermions
	'ngal' : ['A'] ,   # - - - neutralgauge
	'cgal' : ['']  ,  # - - - chargedgauge
	'ancgal' : [''],    # - - - antichargedgauge
	'ngol' : ['']  ,  # - - - neutralgoldstones
	'cgol' : ['']  ,  # - - - chargedgoldstones
	'ancgol' : [''],    # - - - antichargedgoldstones
	'ghl' : ['']   , # - - - ghosts
	'anghl' : [''] ,   # - - - antighosts
	'glul' : ['']  ,  # - - - gluon	
	# - - - - - - Write now their names in LaTeX style, in respective order
	'LAnscl' : [''],
	'LAcscl' : [''],
	'LAancscl' : [''],
	'LAfel' : ['f'],
	'LAanfel'  : ['\\bar{f}'],
	'LAngal' : ['\\gamma'],
	'LAcgal' : [''],
	'LAancgal' : [''],
	'LAngol' : [''],
	'LAcgol' : [''],
	'LAancgol' : [''],
	'LAghl' : [''],
	'LAanghl' : [''],
	'LAglul' : [''],
	# - - - - - - Choose the replacement rules for the particles names from FeynRules to QGRAF  (else, leave it '{}'):
	'FRtoQ' : '{F1 -> f}',
	# - - - - - - Choose a restrictions file for FeynRules (else, leave it ''):
	'FRrestr' : '',
	# - - - - - - Choose simplifications for FeynCalc (else, leave it '{}'):
	'FCsimp' : '{}',	
	# - - - - - - Choose equalities for FeynCalc (else, leave it []):
	'FCeqs' : ['Nc=1','xiA=1','ee=e'],	
	# - - - - - - Set PrMassFL to True if you want the propagators masses to be extracted from the Lagrangean; else, they will be a simple version (in the Feynman gauge):
	'PrMassFL' : True,
	# - - - - - - The following variables concern renormalization
	# - - - - - - In rensimp, you can insert simplifications to be made immediately before renormalization (else, leave it '{}')
	# - - - - - - In renconsnum, you should write the renormalization constants which are numbers, not matrices (else, leave it []);
	# - - - - - - then, in LArenconsnum, the same, but in LaTeX style, in respective order (else, leave it []);
	# - - - - - - in renconsmat, you should write the renormalization constants which are squared matrices (else, leave it []);
	# - - - - - - then, in LArenconsmat, the same, but in LaTeX style, in respective order (else, leave it []);
	# - - - - - - in renconsmatdim, you should write the dimension of the squared matrices just defined (else, leave it []);
	# - - - - - - GFreno should be set to True if you want the renormalization rules to be applied to the gauge fixing Lagrangean; else, False;
	# - - - - - - finally, in renorrules, the renormalization rules (else, leave it [])
	'rensimp' : '{}',	
	'renconsnum' : ['\\[Delta]ee', '\\[Delta]Z3', '\\[Delta]ZfL', '\\[Delta]ZfR', '\\[Delta]mf'],
	'LArenconsnum' : ['\\delta e','\\delta Z_3','\\delta Z^{f,L}','\\delta Z^{f,R}','\\delta m_f'],
	'renconsmat' : [],
	'LArenconsmat' : [],
	'renconsmatdim' : [],
	'GFreno' : False,
	'renorrules' : ['A[\\[Nu]_] -> A[\\[Nu]] + (1/2) \\[Delta]Z3 A[\\[Nu]]', \
		'ee -> ee + \\[Delta]ee ee', \
		'psi1L -> psi1L + (1/2) \\[Delta]ZfL psi1L', \
		'chi1R -> chi1R + (1/2) \\[Delta]ZfR chi1R', \
		'psi1Lbar -> psi1Lbar + (1/2) \\[Delta]ZfL psi1Lbar', \
		'chi1Rbar -> chi1Rbar + (1/2) \\[Delta]ZfR chi1Rbar', \
		'mf -> mf + \\[Delta]mf']
}