# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - Scalar QED - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
content = {
	# - - - - - - Start by writing the 'internal' name of the model, to be used both in the QGRAF model and the Feynrules and Feyncalc folders
	'intname' : 'SQED',
	# - - - - - - Write the 'external' name of the model, to be printed in the final pdfs
	'extname' : 'Scalar QED',
	# - - - - - - Write the particles of your model in QGRAF style (the antiparticles should be in the respective order)	
	'nscl' : [''],    # - - - neutralscalars
	'cscl' : ['HM'],    # - - - chargedscalars
	'ancscl' : ['HP'],    # - - - antichargedscalars
	'fel' : [''],    # - - - fermions
	'anfel'  : [''],    # - - - antifermions
	'ngal' : ['A'],    # - - - neutralgauge
	'cgal' : [''],    # - - - chargedgauge
	'ancgal' : [''],    # - - - antichargedgauge
	'ngol' : [''],    # - - - neutralgoldstones
	'cgol' : [''],    # - - - chargedgoldstones
	'ancgol' : [''],    # - - - antichargedgoldstones
	'ghl' : [''],    # - - - ghosts
	'anghl' : [''],    # - - - antighosts
	'glul' : [''],    # - - - gluon
	# - - - - - - Write now their names in LaTeX style, in respective order		
	'LAnscl' : [''],
	'LAcscl' : ['H^{-}'],
	'LAancscl' : ['H^{+}'],
	'LAfel' : [''],
	'LAanfel'  : [''],
	'LAngal' : ['\\gamma'],
	'LAcgal' : [''],
	'LAancgal' : [''],
	'LAngol' : [''],
	'LAcgol' : [''],
	'LAancgol' : [''],
	'LAghl' : [''],
	'LAanghl' : [''],
	'LAglul' : [''],
	# - - - - - - Choose the replacement rules for the particles names from FeynRules to QGRAF  (else, leave it '{}'):
	'FRtoQ' : '{Phi -> HM}',
	# - - - - - - Choose a restrictions file for FeynRules (else, leave it ''):
	'FRrestr' : '',
	# - - - - - - Choose simplifications for FeynCalc (else, leave it '{}'):
	'FCsimp' : '{}',	
	# - - - - - - Choose equalities for FeynCalc (else, leave it []):
	'FCeqs' : ['xiA=1'],	
	# - - - - - - Set PrMassFL to True if you want the propagators masses to be extracted from the Lagrangean; else, they will be a simple version (in the Feynman gauge):
	'PrMassFL' : True,
	# - - - - - - The following variables concern renormalization
	# - - - - - - In rensimp, you can insert simplifications to be made immediately before renormalization (else, leave it '{}')
	# - - - - - - In renconsnum, you should write the renormalization constants which are numbers, not matrices (else, leave it []);
	# - - - - - - then, in LArenconsnum, the same, but in LaTeX style, in respective order (else, leave it []);
	# - - - - - - in renconsmat, you should write the renormalization constants which are squared matrices (else, leave it []);
	# - - - - - - then, in LArenconsmat, the same, but in LaTeX style, in respective order (else, leave it []);
	# - - - - - - in renconsmatdim, you should write the dimension of the squared matrices just defined (else, leave it []);
	# - - - - - - GFreno should be set to True if you want the renormalization rules to be applied to the gauge fixing Lagrangean; else, False;
	# - - - - - - finally, in renorrules, the renormalization rules (else, leave it [])
	'rensimp' : '{}',
	'renconsnum' : ['\\[Delta]lbd','\\[Delta]ee','\\[Delta]ZHM', '\\[Delta]mHM', '\\[Delta]A', '\\[Delta]Z3'],
	'LArenconsnum' : ['\\delta \\lambda','\\delta e','\\delta Z_{H^{-}}','\\delta m_{H^{-}}','\\delta A','\\delta Z_3'],
	'renconsmat' : [],
	'LArenconsmat' : [],
	'renconsmatdim' : [],
	'renconsmatdim' : [],
	'GFreno' : False,
	'renorrules' : ['Phi -> Phi + (1/2) \\[Delta]ZHM Phi', \
								'Phibar -> Phibar + (1/2) \\[Delta]ZHM Phibar', \
								'lbd -> lbd + \\[Delta]lbd', \
								'ee -> ee + \\[Delta]ee', \
   								'mHM -> mHM + \\[Delta]mHM', \
								'A[\\[Nu]_] -> A[\\[Nu]] + (1/2) \\[Delta]Z3 A[\\[Nu]]']
}