(********** This is the FeynRules model file for QED **********)

(***** Initial information *****)
M$ModelName = "QED";
M$Information = {Authors -> "Duarte Fontes",
                 Institutions -> "Instituto Superior Tecnico",
                 Emails -> "duartefontes@tecnico.ulisboa.pt",
                 Date -> "16.07.2019"};

(***** Parameter list *****)
M$Parameters = {
  mf == {TeX -> Subscript[m,f]},
  ee == {TeX -> e},
  xiA == {TeX -> Subscript[\[Xi],A]}}    

(***** Gauge group list *****)
M$GaugeGroups = {
  U1EM == {
		Abelian -> True,
		GaugeBoson -> A,
		Charge -> Q,
		CouplingConstant -> ee}  }

(***** Particle classes list *****)
M$ClassesDescription = {
  W[1] == {
		ClassName -> psi1L,
		SelfConjugate -> False,
		QuantumNumbers -> {Q-> Q},
		Chirality -> Left},
  W[2] == {
		ClassName -> chi1R,
		SelfConjugate -> False,
		QuantumNumbers -> {Q-> Q},
		Chirality -> Right},
  F[1] == {
		ClassName -> F1,
		SelfConjugate -> False,
		QuantumNumbers -> {Q-> Q},
		Mass -> mf,
		WeylComponents -> {psi1L, chi1R}},
  V[1] == {
		ClassName -> A,
		Mass -> 0,
		SelfConjugate -> True}  }

LGauge := -1/4 FS[A, \[Mu], \[Nu]] FS[A, \[Mu], \[Nu]]
LFermions := I psi1Lbar.sibar[mu].del[psi1L, mu] + I chi1Rbar.si[mu].del[chi1R, mu] \
				 - mf (psi1Lbar.chi1R + chi1Rbar.psi1L) \
				 + ee psi1Lbar.sibar[mu].psi1L A[mu] + ee chi1Rbar.si[mu].chi1R A[mu]
LGF := -1/2/xiA del[A[mu], mu] del[A[nu], nu]